﻿using System;

namespace XorShift
{
	public sealed class Xor128
	{
		private uint x, y, z, w;

		public uint X { get { return this.x; } }
		public uint Y { get { return this.y; } }
		public uint Z { get { return this.z; } }
		public uint W { get { return this.w; } }

		public Xor128(uint seed)
		{
			this.x = 123456789;
			this.y = 362436069;
			this.z = 521288629;
			//this.w = 88675123;
			this.w = seed;
		}

		public Xor128()
			: this((uint)DateTime.Now.Ticks) { }

		public Xor128(uint seedX, uint seedY, uint seedZ, uint seedW)
		{
			if (seedX == 0 && seedY == 0 && seedZ == 0 && seedW == 0)
			{
				throw new ArgumentOutOfRangeException("XorShift のコンストラクタでエラー。4つの seed が全て0です。");
			}
			this.x = seedX;
			this.y = seedY;
			this.z = seedZ;
			this.w = seedW;
		}

		public uint Next()
		{
			uint t = this.x ^ (this.x << 11);
			this.x = this.y;
			this.y = this.z;
			this.z = this.w;
			return this.w = (this.w ^ (this.w >> 19)) ^ (t ^ (t >> 8));
		}

		public int Next(int maxValue)
		{
			return this.Next(0, maxValue);
		}

		public int Next(int minValue, int maxValue)
		{
			if (minValue == maxValue)
			{
				return minValue;
			}
			return (int)((this.Next()) % (maxValue - minValue) + minValue);
		}
	}
}
